#ifndef tile_h_
#define tile_h_

#include <baygui.h>

class mine_tile : public Control {
public:
	typedef enum {
		init,
		init_lock,
		opened,
		marked,
		missmark,
		mark_lock,
		bomb,
		exploded
	} tile_state;
private:
	tile_state state;
	int value;
	mine_tile* around[8];
	static int click_state;
	static Control* click_sender;
	static int bombs_num;
	static int init_tile_num;
	
	void clickProc(MouseEvent*);
	void draw_frame(Graphics*);
	void draw_grid(Graphics*);
	void draw_number(Graphics*);
	void draw_flag(Graphics*);
	void draw_bomb(Graphics*);
	void draw_cross(Graphics*);
	void bit_blt(Graphics*, const int*);
	void send_gameover_to_parent();
	void send_gameover_to_tiles();
	void send_clear_to_parent();
	void open_tile_on_gameover();
	void tiles_open();
	void count_around_bombs_num();
	void initialize();
	void check_gameclear();
public:
	mine_tile(){
		initialize();
	}
	mine_tile(int x, int y){
		initialize();
		setRect(x, y, 16, 16);
	}

	void onPaint(Graphics*);
	void onEvent(Event*);
	void setTileValue(int);
	void setState(tile_state);
	int getTileValue();
	void setAround(mine_tile*, mine_tile*, mine_tile*, mine_tile*, mine_tile*, mine_tile*, mine_tile*, mine_tile*);
};

#endif
